package SCRAM_ExtraBuildRule;
require 5.004;
use Exporter;
@ISA=qw(Exporter);

sub new()
{
  my $class=shift;
  my $self={};
  $self->{template}=shift;
  bless($self, $class);
  return $self;  
}

sub isPublic ()
   {
   my $self=shift;
   my $class = shift;
   if ($class eq "LIBRARY") {return 1;}
   elsif($class eq "SEAL_PLATFORM"){return 1;}
   elsif($class eq "CLASSLIB"){return 1;}
   return 0;
   }

sub Project ()
{
  my $self=shift;
  my $common=$self->{template};
  my $fh=$common->filehandle();
  $common->addPluginSupport("seal","SEALPLUGIN","SealPluginRefresh",'\/plugins$',"SCRAMSTORENAME_LIB_MODULES",".cache",'$name="${name}.reg"',"");
  $common->addProductDirMap ("bin",'\/tests$',"SCRAMSTORENAME_TESTS_BIN",1);
  $common->addProductDirMap ("lib",'\/tests$',"SCRAMSTORENAME_TESTS_LIB",1);
  $common->addPluginDirMap("seal",'\/tests$',"SCRAMSTORENAME_TESTS_LIB_MODULES");
  print $fh "CONFIGDEPS += \$(WORKINGDIR)/cache/project_includes\n",
            "\$(WORKINGDIR)/cache/project_includes: FORCE_TARGET \$(if \$(wildcard \$(SCRAM_SOURCEDIR)/Foundation/SealPlatform),\$(LOCALTOP)/\$(",$common->getProductStore("include"),")/SealPlatform,)\n",
            "\t\@for f in \$(SCRAM_SOURCEDIR)/*/*; do        \\\n",
            "\t  name=`basename \$\$f`;				\\\n",
            "\t  f=\$\$f/\$\$name;					\\\n",
            "\t  [ -d \$\$f ] || continue;                       \\\n",
            "\t  if [ ! -e \$(LOCALTOP)/include/\$\$name ] ; then	\\\n",
            "\t    ln -s ../\$\$f include/\$\$name ;	        \\\n",
            "\t  fi; 						\\\n",
            "\tdone\n",
            "\t\@if [ ! -f \$@ ] ; then touch \$@; echo \$(\@F) DONE; fi\n\n";
  return 1;
}

sub Extra_template()
{
  my $self=shift;
  my $common=$self->{template};
  $common->set("plugin_name",$common->core()->flags("SEAL_PLUGIN_NAME"));
  $common->plugin_template();
  $common->pushstash();
  $common->dict_template();
  $common->popstash();
  return 1;
}

sub SEAL_platform_template()
{
  my $self=shift;
  my $common=$self->{template};
  if ($common->get("suffix") ne ""){return 1;}
  $common->initTemplate_common2all();
  my $safename="SealPlatform";
  $common->set("safename",$safename);
  my $core=$common->core();
  my $types=$core->buildproducts();
  if($types)
  {
    foreach my $type (keys %$types)
    {
      $common->set("type",$type);
      $common->unsupportedProductType();
    }
  }
  my $path=$common->get("path"); my $safepath=$common->get("safepath");
  my $parent=$common->get("parent");
  my $fh=$common->filehandle();
  $core->branchdata()->name($safename);
  print $fh "ifeq (\$(strip \$($parent)),)\n",
            "${safename} := self/${parent}\n",
            "${parent} := ${safename}\n";
  $common->pushstash();$common->library_template_generic();$common->popstash();
  print $fh "${safename}_LOC_USE   := \$(patsubst ${parent},,\$(${safename}_LOC_USE))\n",
            "${safename}_EX_USE    := \$(patsubst ${parent},,\$(${safename}_EX_USE))\n",
            "${safename}_INIT_FUNC := \$\$(eval \$\$(call LogFile,${safename},${path}))\n",
            "${safename}_INIT_FUNC += \$\$(eval \$\$(call ProductCommonVars,${safename},,,\$(${safename}_BuildFile)))\n",
            "${safename}_INIT_FUNC += \$\$(eval \$\$(call SealPlatformRules,${safename},src/${parent},${safepath},\$(",$common->getProductStore("include"),")))\n",
            "endif\n";
            #safename,path,safepath,prodarea
  my $xfhn = "$ENV{LOCALTOP}/$ENV{SCRAM_INTwork}/MakeData/ExtraBuilsRules";
  if (!-d $xfhn){system("mkdir -p $xfhn");}
  $xfhn.="/${safename}.mk";
  my $xfh=undef;
  open ($xfh,">$xfhn") || die "Can not open file for writing: $xfhn";
  print $xfh "define SealPlatformRules\n",
	    ".PHONY: all_\$(3) all_\$(1) \$(3) \$(1)\n",
            "all_\$(3) all_\$(1): \$(1)\n",
            "\$(1) \$(3): \$(LOCALTOP)/\$(4)/\$(1)\n",
            "\$(WORKINGDIR)/\$(2)/config.status: \$(logfile_\$(1)) \$(LOCALTOP)/\$(2)/configure\n",
            "\t\$(startlog_\$(1)) \$(LOCALTOP)/\$(2)/configure -C CPPFLAGS=\"\$\$(strip \$\$(filter -D% -I%,\$\$(\$(1)_CXXFLAGS)) \$\$(INCLUDE:%=-I%) \$\$(\$(1)_LOC_INCLUDE_ALL:%=-I%) \$\$(CPPDEFINES) \$\$(\$(1)_LOC_FLAGS_CPPDEFINES_ALL))\" \\\n",
            "\t  CC=\"\$\$(strip \$(CC))\" CFLAGS=\"\$\$(strip \$\$(\$(1)_LOC_FLAGS_CFLAGS_ALL))\" \\\n",
            "\t  CXX=\"\$\$(strip \$(CXX))\" CXXFLAGS=\"\$\$(strip \$\$(filter-out -ptr% -D% -I%,\$\$(\$(1)_CXXFLAGS)))\" \\\n",
            "\t  LDFLAGS=\"\$\$(\$(1)_LOC_LIBDIR_ALL:%=-L%)\" LIBS=\"\$\$(\$(1)_LOC_LIB_ALL:%=-l%)\" \\\n",
            "\t  --prefix=\$(LOCALTOP)/\$(SCRAM_ARCH) &&\\\n",
            "\tmkdir -p \$\$(\@D) && mv config.* \$\$(\@D) \$(endlog_\$(1))\n",
            "\$(LOCALTOP)/\$(4)/\$(1): \$(WORKINGDIR)/\$(2)/config.status\n",
            "\t\@\$(startlog_\$(1)) if [ -d \$(LOCALTOP)/\$(1) ]; then	\\\n",
            "\tmkdir -p \$(LOCALTOP)/\$(4); rm -rf \$(LOCALTOP)/\$(4)/\$(1); mv \$(LOCALTOP)/\$(1) \$\$\@;	\\\n",
            "\tfi \$(endlog_\$(1))\n",
            ".PHONY: reconf_\$(1)\n",
            "reconf_\$(1):\n",
            "\t\@cd \$(LOCALTOP)/\$(2) &&	\\\n",
            "\taclocal -I src --output=src/aclocal.m4 &&	\\\n",
            "\tautoconf -I src\n",
            "\t\@rm -fr \$(LOCALTOP)/\$(2)/autom4te.cache\n",
            "endef\n";
  close($xfh);
  return 1;
}

1;
